diff -rU5 binutils-060402.orig/bfd/archures.c binutils-060402/bfd/archures.c
--- binutils-060402.orig/bfd/archures.c	2006-03-06 21:42:03.000000000 +0800
+++ binutils-060402/bfd/archures.c	2006-11-16 00:05:33.000000000 +0800
@@ -357,18 +357,21 @@
 .#define bfd_mach_msp12          12
 .#define bfd_mach_msp13          13
 .#define bfd_mach_msp14          14
 .#define bfd_mach_msp15          15
 .#define bfd_mach_msp16          16
+.#define bfd_mach_msp20          20
 .#define bfd_mach_msp21          21
+.#define bfd_mach_msp22          22
 .#define bfd_mach_msp31          31
 .#define bfd_mach_msp32          32
 .#define bfd_mach_msp33          33
 .#define bfd_mach_msp41          41
 .#define bfd_mach_msp42          42
 .#define bfd_mach_msp43          43
 .#define bfd_mach_msp44          44
+.#define bfd_mach_msp46          46
 .  bfd_arch_xc16x,     {* Infineon's XC16X Series.               *}
 .#define bfd_mach_xc16x         1
 .#define bfd_mach_xc16xl        2
 .#define bfd_mach_xc16xs         3
 .  bfd_arch_xtensa,    {* Tensilica's Xtensa cores.  *}
diff -rU5 binutils-060402.orig/bfd/bfd-in2.h binutils-060402/bfd/bfd-in2.h
--- binutils-060402.orig/bfd/bfd-in2.h	2006-03-26 08:38:42.000000000 +0800
+++ binutils-060402/bfd/bfd-in2.h	2006-11-16 00:05:33.000000000 +0800
@@ -1954,18 +1954,21 @@
 #define bfd_mach_msp12          12
 #define bfd_mach_msp13          13
 #define bfd_mach_msp14          14
 #define bfd_mach_msp15          15
 #define bfd_mach_msp16          16
+#define bfd_mach_msp20          20
 #define bfd_mach_msp21          21
+#define bfd_mach_msp22          22
 #define bfd_mach_msp31          31
 #define bfd_mach_msp32          32
 #define bfd_mach_msp33          33
 #define bfd_mach_msp41          41
 #define bfd_mach_msp42          42
 #define bfd_mach_msp43          43
 #define bfd_mach_msp44          44
+#define bfd_mach_msp46          46
   bfd_arch_xc16x,     /* Infineon's XC16X Series.               */
 #define bfd_mach_xc16x         1
 #define bfd_mach_xc16xl        2
 #define bfd_mach_xc16xs         3
   bfd_arch_xtensa,    /* Tensilica's Xtensa cores.  */
diff -rU5 binutils-060402.orig/bfd/cpu-msp430.c binutils-060402/bfd/cpu-msp430.c
--- binutils-060402.orig/bfd/cpu-msp430.c	2005-08-09 16:57:34.000000000 +0800
+++ binutils-060402/bfd/cpu-msp430.c	2006-11-16 00:05:33.000000000 +0800
@@ -62,33 +62,42 @@
   N (16, bfd_mach_msp15, "msp:15", FALSE, & arch_info_struct[6]),
   
   /* msp430x16x.  */
   N (16, bfd_mach_msp16, "msp:16", FALSE, & arch_info_struct[7]),
 
+  /* msp430x20x.  */
+  N (16, bfd_mach_msp20, "msp:20", FALSE, & arch_info_struct[8]),
+
   /* msp430x21x.  */
-  N (16, bfd_mach_msp21, "msp:21", FALSE, & arch_info_struct[8]),
+  N (16, bfd_mach_msp21, "msp:21", FALSE, & arch_info_struct[9]),
+
+  /* msp430x22x.  */
+  N (16, bfd_mach_msp22, "msp:22", FALSE, & arch_info_struct[10]),
 
   /* msp430x31x.  */
-  N (16, bfd_mach_msp31, "msp:31", FALSE, & arch_info_struct[9]), 
+  N (16, bfd_mach_msp31, "msp:31", FALSE, & arch_info_struct[11]), 
 
   /* msp430x32x.  */
-  N (16, bfd_mach_msp32, "msp:32", FALSE, & arch_info_struct[10]), 
+  N (16, bfd_mach_msp32, "msp:32", FALSE, & arch_info_struct[12]), 
 
   /* msp430x33x.  */
-  N (16, bfd_mach_msp33, "msp:33", FALSE, & arch_info_struct[11]),
+  N (16, bfd_mach_msp33, "msp:33", FALSE, & arch_info_struct[13]),
   
   /* msp430x41x.  */
-  N (16, bfd_mach_msp41, "msp:41", FALSE, & arch_info_struct[12]),
+  N (16, bfd_mach_msp41, "msp:41", FALSE, & arch_info_struct[14]),
 
   /* msp430x42x.  */
-  N (16, bfd_mach_msp42, "msp:42", FALSE, & arch_info_struct[13]),
+  N (16, bfd_mach_msp42, "msp:42", FALSE, & arch_info_struct[15]),
 
   /* msp430x43x.  */
-  N (16, bfd_mach_msp43, "msp:43", FALSE, & arch_info_struct[14]),
+  N (16, bfd_mach_msp43, "msp:43", FALSE, & arch_info_struct[16]),
 
   /* msp430x44x.  */
-  N (16, bfd_mach_msp43, "msp:44", FALSE, NULL)
+  N (16, bfd_mach_msp44, "msp:44", FALSE, & arch_info_struct[17]),
+
+  /* msp430x46xx.  */
+  N (16, bfd_mach_msp46, "msp:46", FALSE, NULL)
 };
 
 const bfd_arch_info_type bfd_msp430_arch =
   N (16, bfd_mach_msp14, "msp:14", TRUE, & arch_info_struct[0]);
 
diff -rU5 binutils-060402.orig/bfd/doc/archures.texi binutils-060402/bfd/doc/archures.texi
--- binutils-060402.orig/bfd/doc/archures.texi	2006-04-02 13:39:37.000000000 +0800
+++ binutils-060402/bfd/doc/archures.texi	2006-11-16 00:05:33.000000000 +0800
@@ -323,18 +323,21 @@
 #define bfd_mach_msp12          12
 #define bfd_mach_msp13          13
 #define bfd_mach_msp14          14
 #define bfd_mach_msp15          15
 #define bfd_mach_msp16          16
+#define bfd_mach_msp20          20
 #define bfd_mach_msp21          21
+#define bfd_mach_msp22          22
 #define bfd_mach_msp31          31
 #define bfd_mach_msp32          32
 #define bfd_mach_msp33          33
 #define bfd_mach_msp41          41
 #define bfd_mach_msp42          42
 #define bfd_mach_msp43          43
 #define bfd_mach_msp44          44
+#define bfd_mach_msp46          46
   bfd_arch_xc16x,     /* Infineon's XC16X Series.               */
 #define bfd_mach_xc16x         1
 #define bfd_mach_xc16xl        2
 #define bfd_mach_xc16xs         3
   bfd_arch_xtensa,    /* Tensilica's Xtensa cores.  */
diff -rU5 binutils-060402.orig/bfd/elf32-msp430.c binutils-060402/bfd/elf32-msp430.c
--- binutils-060402.orig/bfd/elf32-msp430.c	2005-09-01 19:27:15.000000000 +0800
+++ binutils-060402/bfd/elf32-msp430.c	2006-11-16 00:05:33.000000000 +0800
@@ -573,10 +573,22 @@
 
     case bfd_mach_msp16:
       val = E_MSP430_MACH_MSP430x16;
       break;
 
+    case bfd_mach_msp20:
+      val = E_MSP430_MACH_MSP430x20;
+      break;
+
+    case bfd_mach_msp21:
+      val = E_MSP430_MACH_MSP430x21;
+      break;
+
+    case bfd_mach_msp22:
+      val = E_MSP430_MACH_MSP430x22;
+      break;
+
     case bfd_mach_msp31:
       val = E_MSP430_MACH_MSP430x31;
       break;
 
     case bfd_mach_msp32:
@@ -600,10 +612,14 @@
       break;
 
     case bfd_mach_msp44:
       val = E_MSP430_MACH_MSP430x44;
       break;
+
+    case bfd_mach_msp46:
+      val = E_MSP430_MACH_MSP430x46;
+      break;
     }
 
   elf_elfheader (abfd)->e_machine = EM_MSP430;
   elf_elfheader (abfd)->e_flags &= ~EF_MSP430_MACH;
   elf_elfheader (abfd)->e_flags |= val;
@@ -650,10 +666,22 @@
 
 	case E_MSP430_MACH_MSP430x16:
 	  e_set = bfd_mach_msp16;
 	  break;
 
+	case E_MSP430_MACH_MSP430x20:
+	  e_set = bfd_mach_msp20;
+	  break;
+
+	case E_MSP430_MACH_MSP430x21:
+	  e_set = bfd_mach_msp21;
+	  break;
+
+	case E_MSP430_MACH_MSP430x22:
+	  e_set = bfd_mach_msp22;
+	  break;
+
 	case E_MSP430_MACH_MSP430x31:
 	  e_set = bfd_mach_msp31;
 	  break;
 
 	case E_MSP430_MACH_MSP430x32:
@@ -677,10 +705,14 @@
 	  break;
 
 	case E_MSP430_MACH_MSP430x44:
 	  e_set = bfd_mach_msp44;
 	  break;
+
+	case E_MSP430_MACH_MSP430x46:
+	  e_set = bfd_mach_msp46;
+	  break;
 	}
     }
 
   return bfd_default_set_arch_mach (abfd, bfd_arch_msp430, e_set);
 }
diff -rU5 binutils-060402.orig/gas/config/tc-msp430.c binutils-060402/gas/config/tc-msp430.c
--- binutils-060402.orig/gas/config/tc-msp430.c	2005-09-09 16:46:19.000000000 +0800
+++ binutils-060402/gas/config/tc-msp430.c	2006-11-16 00:05:33.000000000 +0800
@@ -247,95 +247,127 @@
 #define MSP430_ISA_12   12
 #define MSP430_ISA_13   13
 #define MSP430_ISA_14   14
 #define MSP430_ISA_15   15
 #define MSP430_ISA_16   16
+#define MSP430_ISA_20   20
 #define MSP430_ISA_21   21
+#define MSP430_ISA_22   22
 #define MSP430_ISA_31   31
 #define MSP430_ISA_32   32
 #define MSP430_ISA_33   33
 #define MSP430_ISA_41   41
 #define MSP430_ISA_42   42
 #define MSP430_ISA_43   43
 #define MSP430_ISA_44   44
+#define MSP430_ISA_46   46
 
 #define CHECK_RELOC_MSP430 		((imm_op || byte_op)?BFD_RELOC_MSP430_16_BYTE:BFD_RELOC_MSP430_16)
 #define CHECK_RELOC_MSP430_PCREL	((imm_op || byte_op)?BFD_RELOC_MSP430_16_PCREL_BYTE:BFD_RELOC_MSP430_16_PCREL)
 
 static struct mcu_type_s mcu_types[] =
 {
-  {"msp1",        MSP430_ISA_11, bfd_mach_msp11},
-  {"msp2",        MSP430_ISA_14, bfd_mach_msp14},
-  {"msp430x110",  MSP430_ISA_11, bfd_mach_msp11},
-  {"msp430x112",  MSP430_ISA_11, bfd_mach_msp11},
-  {"msp430x1101", MSP430_ISA_110, bfd_mach_msp110},
-  {"msp430x1111", MSP430_ISA_110, bfd_mach_msp110},
-  {"msp430x1121", MSP430_ISA_110, bfd_mach_msp110},
-  {"msp430x1122", MSP430_ISA_11, bfd_mach_msp110},
-  {"msp430x1132", MSP430_ISA_11, bfd_mach_msp110},
-
-  {"msp430x122",  MSP430_ISA_12, bfd_mach_msp12},
-  {"msp430x123",  MSP430_ISA_12, bfd_mach_msp12},
-  {"msp430x1222", MSP430_ISA_12, bfd_mach_msp12},
-  {"msp430x1232", MSP430_ISA_12, bfd_mach_msp12},
-
-  {"msp430x133",  MSP430_ISA_13, bfd_mach_msp13},
-  {"msp430x135",  MSP430_ISA_13, bfd_mach_msp13},
-  {"msp430x1331", MSP430_ISA_13, bfd_mach_msp13},
-  {"msp430x1351", MSP430_ISA_13, bfd_mach_msp13},
-  {"msp430x147",  MSP430_ISA_14, bfd_mach_msp14},
-  {"msp430x148",  MSP430_ISA_14, bfd_mach_msp14},
-  {"msp430x149",  MSP430_ISA_14, bfd_mach_msp14},
-
-  {"msp430x155",  MSP430_ISA_15, bfd_mach_msp15},
-  {"msp430x156",  MSP430_ISA_15, bfd_mach_msp15},
-  {"msp430x157",  MSP430_ISA_15, bfd_mach_msp15},
-  {"msp430x167",  MSP430_ISA_16, bfd_mach_msp16},
-  {"msp430x168",  MSP430_ISA_16, bfd_mach_msp16},
-  {"msp430x169",  MSP430_ISA_16, bfd_mach_msp16},
-  {"msp430x1610", MSP430_ISA_16, bfd_mach_msp16},
-  {"msp430x1611", MSP430_ISA_16, bfd_mach_msp16},
-  {"msp430x1612", MSP430_ISA_16, bfd_mach_msp16},
-
-  {"msp430x2101", MSP430_ISA_21, bfd_mach_msp21},
-  {"msp430x2111", MSP430_ISA_21, bfd_mach_msp21},
-  {"msp430x2121", MSP430_ISA_21, bfd_mach_msp21},
-  {"msp430x2131", MSP430_ISA_21, bfd_mach_msp21},
+  {"msp1",         MSP430_ISA_11,  bfd_mach_msp11},
+  {"msp2",         MSP430_ISA_14,  bfd_mach_msp14},
+  {"msp430x110",   MSP430_ISA_11,  bfd_mach_msp11},
+  {"msp430x112",   MSP430_ISA_11,  bfd_mach_msp11},
+  {"msp430x1101",  MSP430_ISA_110, bfd_mach_msp110},
+  {"msp430x1111",  MSP430_ISA_110, bfd_mach_msp110},
+  {"msp430x1121",  MSP430_ISA_110, bfd_mach_msp110},
+  {"msp430x1122",  MSP430_ISA_11,  bfd_mach_msp110},
+  {"msp430x1132",  MSP430_ISA_11,  bfd_mach_msp110},
+
+  {"msp430x122",   MSP430_ISA_12,  bfd_mach_msp12},
+  {"msp430x123",   MSP430_ISA_12,  bfd_mach_msp12},
+  {"msp430x1222",  MSP430_ISA_12,  bfd_mach_msp12},
+  {"msp430x1232",  MSP430_ISA_12,  bfd_mach_msp12},
+
+  {"msp430x133",   MSP430_ISA_13,  bfd_mach_msp13},
+  {"msp430x135",   MSP430_ISA_13,  bfd_mach_msp13},
+  {"msp430x1331",  MSP430_ISA_13,  bfd_mach_msp13},
+  {"msp430x1351",  MSP430_ISA_13,  bfd_mach_msp13},
+  {"msp430x147",   MSP430_ISA_14,  bfd_mach_msp14},
+  {"msp430x148",   MSP430_ISA_14,  bfd_mach_msp14},
+  {"msp430x149",   MSP430_ISA_14,  bfd_mach_msp14},
+  {"msp430x1471",  MSP430_ISA_14,  bfd_mach_msp14},
+  {"msp430x1481",  MSP430_ISA_14,  bfd_mach_msp14},
+  {"msp430x1491",  MSP430_ISA_14,  bfd_mach_msp14},
+
+  {"msp430x155",   MSP430_ISA_15,  bfd_mach_msp15},
+  {"msp430x156",   MSP430_ISA_15,  bfd_mach_msp15},
+  {"msp430x157",   MSP430_ISA_15,  bfd_mach_msp15},
+  {"msp430x167",   MSP430_ISA_16,  bfd_mach_msp16},
+  {"msp430x168",   MSP430_ISA_16,  bfd_mach_msp16},
+  {"msp430x169",   MSP430_ISA_16,  bfd_mach_msp16},
+  {"msp430x1610",  MSP430_ISA_16,  bfd_mach_msp16},
+  {"msp430x1611",  MSP430_ISA_16,  bfd_mach_msp16},
+  {"msp430x1612",  MSP430_ISA_16,  bfd_mach_msp16},
+
+  {"msp430x2001",  MSP430_ISA_20,  bfd_mach_msp20},
+  {"msp430x2011",  MSP430_ISA_20,  bfd_mach_msp20},
+
+  {"msp430x2002",  MSP430_ISA_20,  bfd_mach_msp20},
+  {"msp430x2012",  MSP430_ISA_20,  bfd_mach_msp20},
+
+  {"msp430x2003",  MSP430_ISA_20,  bfd_mach_msp20},
+  {"msp430x2013",  MSP430_ISA_20,  bfd_mach_msp20},
+
+  {"msp430x2101",  MSP430_ISA_21,  bfd_mach_msp21},
+  {"msp430x2111",  MSP430_ISA_21,  bfd_mach_msp21},
+  {"msp430x2121",  MSP430_ISA_21,  bfd_mach_msp21},
+  {"msp430x2131",  MSP430_ISA_21,  bfd_mach_msp21},
+
+  {"msp430x2234",  MSP430_ISA_22,  bfd_mach_msp22},
+  {"msp430x2254",  MSP430_ISA_22,  bfd_mach_msp22},
+  {"msp430x2274",  MSP430_ISA_22,  bfd_mach_msp22},
   
-  {"msp430x311",  MSP430_ISA_31, bfd_mach_msp31},
-  {"msp430x312",  MSP430_ISA_31, bfd_mach_msp31},
-  {"msp430x313",  MSP430_ISA_31, bfd_mach_msp31},
-  {"msp430x314",  MSP430_ISA_31, bfd_mach_msp31},
-  {"msp430x315",  MSP430_ISA_31, bfd_mach_msp31},
-  {"msp430x323",  MSP430_ISA_32, bfd_mach_msp32},
-  {"msp430x325",  MSP430_ISA_32, bfd_mach_msp32},
-  {"msp430x336",  MSP430_ISA_33, bfd_mach_msp33},
-  {"msp430x337",  MSP430_ISA_33, bfd_mach_msp33},
-
-  {"msp430x412",  MSP430_ISA_41, bfd_mach_msp41},
-  {"msp430x413",  MSP430_ISA_41, bfd_mach_msp41},
-  {"msp430x415",  MSP430_ISA_41, bfd_mach_msp41},
-  {"msp430x417",  MSP430_ISA_41, bfd_mach_msp41},
-
-  {"msp430xE423", MSP430_ISA_42, bfd_mach_msp42},
-  {"msp430xE425", MSP430_ISA_42, bfd_mach_msp42},
-  {"msp430xE427", MSP430_ISA_42, bfd_mach_msp42},
-
-  {"msp430xW423", MSP430_ISA_42, bfd_mach_msp42},
-  {"msp430xW425", MSP430_ISA_42, bfd_mach_msp42},
-  {"msp430xW427", MSP430_ISA_42, bfd_mach_msp42},
-
-  {"msp430xG437", MSP430_ISA_43, bfd_mach_msp43},
-  {"msp430xG438", MSP430_ISA_43, bfd_mach_msp43},
-  {"msp430xG439", MSP430_ISA_43, bfd_mach_msp43},
-
-  {"msp430x435",  MSP430_ISA_43, bfd_mach_msp43},
-  {"msp430x436",  MSP430_ISA_43, bfd_mach_msp43},
-  {"msp430x437",  MSP430_ISA_43, bfd_mach_msp43},
-  {"msp430x447",  MSP430_ISA_44, bfd_mach_msp44},
-  {"msp430x448",  MSP430_ISA_44, bfd_mach_msp44},
-  {"msp430x449",  MSP430_ISA_44, bfd_mach_msp44},
+  {"msp430x311",   MSP430_ISA_31,  bfd_mach_msp31},
+  {"msp430x312",   MSP430_ISA_31,  bfd_mach_msp31},
+  {"msp430x313",   MSP430_ISA_31,  bfd_mach_msp31},
+  {"msp430x314",   MSP430_ISA_31,  bfd_mach_msp31},
+  {"msp430x315",   MSP430_ISA_31,  bfd_mach_msp31},
+  {"msp430x323",   MSP430_ISA_32,  bfd_mach_msp32},
+  {"msp430x325",   MSP430_ISA_32,  bfd_mach_msp32},
+  {"msp430x336",   MSP430_ISA_33,  bfd_mach_msp33},
+  {"msp430x337",   MSP430_ISA_33,  bfd_mach_msp33},
+
+  {"msp430x412",   MSP430_ISA_41,  bfd_mach_msp41},
+  {"msp430x413",   MSP430_ISA_41,  bfd_mach_msp41},
+  {"msp430x415",   MSP430_ISA_41,  bfd_mach_msp41},
+  {"msp430x417",   MSP430_ISA_41,  bfd_mach_msp41},
+
+  {"msp430x423",   MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430x425",   MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430x427",   MSP430_ISA_42,  bfd_mach_msp42},
+
+  {"msp430x4250",  MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430x4260",  MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430x4270",  MSP430_ISA_42,  bfd_mach_msp42},
+
+  {"msp430xE423",  MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430xE425",  MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430xE427",  MSP430_ISA_42,  bfd_mach_msp42},
+
+  {"msp430xW423",  MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430xW425",  MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430xW427",  MSP430_ISA_42,  bfd_mach_msp42},
+
+  {"msp430xG437",  MSP430_ISA_43,  bfd_mach_msp43},
+  {"msp430xG438",  MSP430_ISA_43,  bfd_mach_msp43},
+  {"msp430xG439",  MSP430_ISA_43,  bfd_mach_msp43},
+
+  {"msp430x435",   MSP430_ISA_43,  bfd_mach_msp43},
+  {"msp430x436",   MSP430_ISA_43,  bfd_mach_msp43},
+  {"msp430x437",   MSP430_ISA_43,  bfd_mach_msp43},
+  {"msp430x447",   MSP430_ISA_44,  bfd_mach_msp44},
+  {"msp430x448",   MSP430_ISA_44,  bfd_mach_msp44},
+  {"msp430x449",   MSP430_ISA_44,  bfd_mach_msp44},
+
+  {"msp430xG4616", MSP430_ISA_46,  bfd_mach_msp46},
+  {"msp430xG4617", MSP430_ISA_46,  bfd_mach_msp46},
+  {"msp430xG4618", MSP430_ISA_46,  bfd_mach_msp46},
+  {"msp430xG4619", MSP430_ISA_46,  bfd_mach_msp46},
 
   {NULL, 0, 0}
 };
 
 
@@ -795,30 +827,39 @@
 md_show_usage (FILE * stream)
 {
   fprintf (stream,
 	   _("MSP430 options:\n"
 	     "  -mmcu=[msp430-name] select microcontroller type\n"
-	     "                  msp430x110  msp430x112\n"
-	     "                  msp430x1101 msp430x1111\n"
-	     "                  msp430x1121 msp430x1122 msp430x1132\n"
-	     "                  msp430x122  msp430x123\n"
-	     "                  msp430x1222 msp430x1232\n"
-	     "                  msp430x133  msp430x135\n"
-	     "                  msp430x1331 msp430x1351\n"
-	     "                  msp430x147  msp430x148  msp430x149\n"
-	     "                  msp430x155  msp430x156  msp430x157\n"
-	     "                  msp430x167  msp430x168  msp430x169\n"
-	     "                  msp430x1610 msp430x1611 msp430x1612\n"
-	     "                  msp430x311  msp430x312  msp430x313  msp430x314  msp430x315\n"
-	     "                  msp430x323  msp430x325\n"
-	     "                  msp430x336  msp430x337\n"
-	     "                  msp430x412  msp430x413  msp430x415  msp430x417\n"
-	     "                  msp430xE423 msp430xE425 msp430E427\n"
-	     "                  msp430xW423 msp430xW425 msp430W427\n"
-	     "                  msp430xG437 msp430xG438 msp430G439\n"
-	     "                  msp430x435  msp430x436  msp430x437\n"
-	     "                  msp430x447  msp430x448  msp430x449\n"));
+	     "                  msp430x110   msp430x112\n"
+	     "                  msp430x1101  msp430x1111  msp430x1121\n"
+	     "                  msp430x1122  msp430x1132\n"
+	     "                  msp430x122   msp430x123\n"
+	     "                  msp430x1222  msp430x1232\n"
+	     "                  msp430x133   msp430x135\n"
+	     "                  msp430x1331  msp430x1351\n"
+	     "                  msp430x147   msp430x148   msp430x149\n"
+	     "                  msp430x1471  msp430x1481  msp430x1491\n"
+	     "                  msp430x155   msp430x156   msp430x157\n"
+	     "                  msp430x167   msp430x168   msp430x169\n"
+	     "                  msp430x1610  msp430x1611  msp430x1612\n"
+	     "                  msp430x2001  msp430x2011\n"
+	     "                  msp430x2002  msp430x2012\n"
+	     "                  msp430x2003  msp430x2013\n"
+	     "                  msp430x2101  msp430x2111  msp430x2121  msp430x2131\n"
+	     "                  msp430x2234  msp430x2254  msp430x2274\n"
+	     "                  msp430x311   msp430x312   msp430x313   msp430x314  msp430x315\n"
+	     "                  msp430x323   msp430x325\n" 
+	     "                  msp430x336   msp430x337\n"
+	     "                  msp430x412   msp430x413   msp430x415   msp430x417\n"
+	     "                  msp430x423   msp430x425   msp430427\n"
+	     "                  msp430x4250  msp430x4260  msp4304270\n"
+	     "                  msp430xE423  msp430xE425  msp430E427\n"
+	     "                  msp430xW423  msp430xW425  msp430W427\n"
+	     "                  msp430xG437  msp430xG438  msp430G439\n"
+	     "                  msp430x435   msp430x436   msp430x437\n"
+	     "                  msp430x447   msp430x448   msp430x449\n"
+	     "                  msp430xG4616 msp430xG4617 msp430xG4618 msp430xG4619\n"));
   fprintf (stream,
 	   _("  -mQ - enable relaxation at assembly time. DANGEROUS!\n"
 	     "  -mP - enable polymorph instructions\n"));
 
   show_mcu_list (stream);
diff -rU5 binutils-060402.orig/include/elf/msp430.h binutils-060402/include/elf/msp430.h
--- binutils-060402.orig/include/elf/msp430.h	2005-05-10 18:21:10.000000000 +0800
+++ binutils-060402/include/elf/msp430.h	2006-11-16 00:05:33.000000000 +0800
@@ -24,24 +24,28 @@
 #include "elf/reloc-macros.h"
 
 /* Processor specific flags for the ELF header e_flags field.  */
 #define EF_MSP430_MACH 		0xff
 
-#define E_MSP430_MACH_MSP430x11  11
-#define E_MSP430_MACH_MSP430x11x1  110
-#define E_MSP430_MACH_MSP430x12  12
-#define E_MSP430_MACH_MSP430x13  13
-#define E_MSP430_MACH_MSP430x14  14
-#define E_MSP430_MACH_MSP430x15  15
-#define E_MSP430_MACH_MSP430x16  16
-#define E_MSP430_MACH_MSP430x31  31
-#define E_MSP430_MACH_MSP430x32  32
-#define E_MSP430_MACH_MSP430x33  33
-#define E_MSP430_MACH_MSP430x41  41
-#define E_MSP430_MACH_MSP430x42  42
-#define E_MSP430_MACH_MSP430x43  43
-#define E_MSP430_MACH_MSP430x44  44
+#define E_MSP430_MACH_MSP430x11   11
+#define E_MSP430_MACH_MSP430x11x1 110
+#define E_MSP430_MACH_MSP430x12   12
+#define E_MSP430_MACH_MSP430x13   13
+#define E_MSP430_MACH_MSP430x14   14
+#define E_MSP430_MACH_MSP430x15   15
+#define E_MSP430_MACH_MSP430x16   16
+#define E_MSP430_MACH_MSP430x20   20
+#define E_MSP430_MACH_MSP430x21   21
+#define E_MSP430_MACH_MSP430x22   22
+#define E_MSP430_MACH_MSP430x31   31
+#define E_MSP430_MACH_MSP430x32   32
+#define E_MSP430_MACH_MSP430x33   33
+#define E_MSP430_MACH_MSP430x41   41
+#define E_MSP430_MACH_MSP430x42   42
+#define E_MSP430_MACH_MSP430x43   43
+#define E_MSP430_MACH_MSP430x44   44
+#define E_MSP430_MACH_MSP430x46   46
 
 /* Relocations.  */
 START_RELOC_NUMBERS (elf_msp430_reloc_type)
      RELOC_NUMBER (R_MSP430_NONE,		0)
      RELOC_NUMBER (R_MSP430_32,			1)
diff -rU5 binutils-060402.orig/ld/configure.tgt binutils-060402/ld/configure.tgt
--- binutils-060402.orig/ld/configure.tgt	2006-03-26 08:46:13.000000000 +0800
+++ binutils-060402/ld/configure.tgt	2006-11-16 00:05:33.000000000 +0800
@@ -350,11 +350,11 @@
 mn10300-*-*)		targ_emul=mn10300
 			;;
 mt-*elf)                targ_emul=elf32mt
 			;;
 msp430-*-*)             targ_emul=msp430x110
-                        targ_extra_emuls="msp430x112 msp430x1101 msp430x1111 msp430x1121 msp430x1122 msp430x1132 msp430x122 msp430x123 msp430x1222 msp430x1232 msp430x133 msp430x135 msp430x1331 msp430x1351 msp430x147 msp430x148 msp430x149 msp430x155 msp430x156 msp430x157 msp430x167 msp430x168 msp430x169 msp430x1610 msp430x1611 msp430x1612 msp430x2101 msp430x2111 msp430x2121 msp430x2131 msp430x311 msp430x312 msp430x313 msp430x314 msp430x315 msp430x323 msp430x325 msp430x336 msp430x337 msp430x412 msp430x413 msp430x415 msp430x417 msp430xE423 msp430xE425 msp430xE427 msp430xW423 msp430xW425 msp430xW427 msp430xG437 msp430xG438 msp430xG439 msp430x435 msp430x436 msp430x437 msp430x447 msp430x448 msp430x449"
+                        targ_extra_emuls="msp430x112 msp430x1101 msp430x1111 msp430x1121 msp430x1122 msp430x1132 msp430x122 msp430x123 msp430x1222 msp430x1232 msp430x133 msp430x135 msp430x1331 msp430x1351 msp430x147 msp430x148 msp430x149 msp430x1471 msp430x1481 msp430x1491 msp430x155 msp430x156 msp430x157 msp430x167 msp430x168 msp430x169 msp430x1610 msp430x1611 msp430x1612 msp430x2001 msp430x2011 msp430x2002 msp430x2012 msp430x2003 msp430x2013 msp430x2101 msp430x2111 msp430x2121 msp430x2131 msp430x2234 msp430x2254 msp430x2274 msp430x311 msp430x312 msp430x313 msp430x314 msp430x315 msp430x323 msp430x325 msp430x336 msp430x337 msp430x412 msp430x413 msp430x415 msp430x417 msp430x423 msp430x425 msp430x427 msp430x4250 msp430x4260 msp430x4270 msp430xE423 msp430xE425 msp430xE427 msp430xW423 msp430xW425 msp430xW427 msp430xG437 msp430xG438 msp430xG439 msp430x435 msp430x436 msp430x437 msp430x447 msp430x448 msp430x449 msp430xG4616 msp430xG4617 msp430xG4618 msp430xG4619"
 			;;
 ns32k-pc532-mach* | ns32k-pc532-ux*)  targ_emul=pc532macha ;;
 ns32k-*-netbsd* | ns32k-pc532-lites*) targ_emul=ns32knbsd
 			;;
 openrisc-*-*)		targ_emul=elf32openrisc ;;
diff -rU5 binutils-060402.orig/ld/emulparams/msp430all.sh binutils-060402/ld/emulparams/msp430all.sh
--- binutils-060402.orig/ld/emulparams/msp430all.sh	2005-08-09 01:08:04.000000000 +0800
+++ binutils-060402/ld/emulparams/msp430all.sh	2006-11-16 00:05:33.000000000 +0800
@@ -15,10 +15,12 @@
 
 ROM_START=0xfc00
 ROM_SIZE=0x3e0
 RAM_START=0x0200
 RAM_SIZE=128
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x280
 fi
 
 if [ "${MSP430_NAME}" = "msp430x1101" ] ; then
@@ -32,10 +34,12 @@
 
 ROM_START=0xfc00
 ROM_SIZE=0x3e0
 RAM_START=0x0200
 RAM_SIZE=128
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x280
 fi
 
 if [ "${MSP430_NAME}" = "msp430x1111" ] ; then
@@ -49,10 +53,12 @@
 
 ROM_START=0xf800
 ROM_SIZE=0x07e0
 RAM_START=0x0200
 RAM_SIZE=128
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x280
 fi
 
 if [ "${MSP430_NAME}" = "msp430x112" ] ; then
@@ -66,10 +72,12 @@
 
 ROM_START=0xf000
 ROM_SIZE=0xfe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x1121" ] ; then
@@ -83,10 +91,12 @@
 
 ROM_START=0xf000
 ROM_SIZE=0x0fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x1122" ] ; then
@@ -100,10 +110,12 @@
 
 ROM_START=0xf000
 ROM_SIZE=0x0fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x1132" ] ; then
@@ -117,10 +129,12 @@
 
 ROM_START=0xe000
 ROM_SIZE=0x1fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x122" ] ; then
@@ -134,10 +148,12 @@
 
 ROM_START=0xf000
 ROM_SIZE=0xfe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x1222" ] ; then
@@ -151,10 +167,12 @@
 
 ROM_START=0xf000
 ROM_SIZE=0xfe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x123" ] ; then
@@ -168,10 +186,12 @@
 
 ROM_START=0xe000
 ROM_SIZE=0x1fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x1232" ] ; then
@@ -185,10 +205,12 @@
 
 ROM_START=0xe000
 ROM_SIZE=0x1fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x133" ] ; then
@@ -202,10 +224,12 @@
 
 ROM_START=0xe000
 ROM_SIZE=0x1fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x1331" ] ; then
@@ -219,10 +243,12 @@
 
 ROM_START=0xe000
 ROM_SIZE=0x1fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x135" ] ; then
@@ -236,10 +262,12 @@
 
 ROM_START=0xc000
 ROM_SIZE=0x3fe0
 RAM_START=0x0200
 RAM_SIZE=512
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x400
 fi
 
 if [ "${MSP430_NAME}" = "msp430x1351" ] ; then
@@ -253,10 +281,12 @@
 
 ROM_START=0xc000
 ROM_SIZE=0x3fe0
 RAM_START=0x0200
 RAM_SIZE=512
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x400
 fi
 
 if [ "${MSP430_NAME}" = "msp430x147" ] ; then
@@ -270,10 +300,12 @@
 
 ROM_START=0x8000
 ROM_SIZE=0x7fe0
 RAM_START=0x0200
 RAM_SIZE=1K
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x600
 fi
 
 if [ "${MSP430_NAME}" = "msp430x148" ] ; then
@@ -287,10 +319,12 @@
 
 ROM_START=0x4000
 ROM_SIZE=0xbfe0
 RAM_START=0x0200
 RAM_SIZE=0x0800
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0xa00
 fi
 
 if [ "${MSP430_NAME}" = "msp430x149" ] ; then
@@ -304,10 +338,69 @@
 
 ROM_START=0x1100
 ROM_SIZE=0xeee0
 RAM_START=0x0200
 RAM_SIZE=0x0800
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0xa00
+fi
+
+if [ "${MSP430_NAME}" = "msp430x1471" ] ; then
+ARCH=msp:14
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0x8000
+ROM_SIZE=0x7fe0
+RAM_START=0x0200
+RAM_SIZE=1K
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x600
+fi
+
+if [ "${MSP430_NAME}" = "msp430x1481" ] ; then
+ARCH=msp:14
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0x4000
+ROM_SIZE=0xbfe0
+RAM_START=0x0200
+RAM_SIZE=0x0800
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0xa00
+fi
+
+if [ "${MSP430_NAME}" = "msp430x1491" ] ; then
+ARCH=msp:14
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0x1100
+ROM_SIZE=0xeee0
+RAM_START=0x0200
+RAM_SIZE=0x0800
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0xa00
 fi
 
 if [ "${MSP430_NAME}" = "msp430x155" ] ; then
@@ -321,10 +414,12 @@
 
 ROM_START=0xc000
 ROM_SIZE=0x3fe0
 RAM_START=0x0200
 RAM_SIZE=512
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x400
 fi
 
 if [ "${MSP430_NAME}" = "msp430x156" ] ; then
@@ -338,10 +433,12 @@
 
 ROM_START=0xa000
 ROM_SIZE=0x5fe0
 RAM_START=0x0200
 RAM_SIZE=512
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x400
 fi
 
 if [ "${MSP430_NAME}" = "msp430x157" ] ; then
@@ -355,10 +452,12 @@
 
 ROM_START=0x8000
 ROM_SIZE=0x7fe0
 RAM_START=0x0200
 RAM_SIZE=1K
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x600
 fi
 
 if [ "${MSP430_NAME}" = "msp430x167" ] ; then
@@ -372,10 +471,12 @@
 
 ROM_START=0x8000
 ROM_SIZE=0x7fe0
 RAM_START=0x0200
 RAM_SIZE=1K
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x600
 fi
 
 if [ "${MSP430_NAME}" = "msp430x168" ] ; then
@@ -389,10 +490,12 @@
 
 ROM_START=0x4000
 ROM_SIZE=0xbfe0
 RAM_START=0x0200
 RAM_SIZE=0x0800
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0xa00
 fi
 
 if [ "${MSP430_NAME}" = "msp430x169" ] ; then
@@ -406,10 +509,12 @@
 
 ROM_START=0x1100
 ROM_SIZE=0xeee0
 RAM_START=0x0200
 RAM_SIZE=0x0800
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0xa00
 fi
 
 if [ "${MSP430_NAME}" = "msp430x1610" ] ; then
@@ -423,10 +528,12 @@
 
 ROM_START=0x8000
 ROM_SIZE=0x7fe0
 RAM_START=0x1100
 RAM_SIZE=0x1400
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x2500
 fi
 
 if [ "${MSP430_NAME}" = "msp430x1611" ] ; then
@@ -440,10 +547,12 @@
 
 ROM_START=0x4000
 ROM_SIZE=0xbfe0
 RAM_START=0x1100
 RAM_SIZE=0x2800
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x3900
 fi
 
 if [ "${MSP430_NAME}" = "msp430x1612" ] ; then
@@ -457,14 +566,130 @@
 
 ROM_START=0x2500
 ROM_SIZE=0xdae0
 RAM_START=0x1100
 RAM_SIZE=0x1400
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x2500
 fi
 
+if [ "${MSP430_NAME}" = "msp430x2001" ] ; then
+ARCH=msp:20
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0xFC00
+ROM_SIZE=0x03e0
+RAM_START=0x0200
+RAM_SIZE=128
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x280
+fi
+
+if [ "${MSP430_NAME}" = "msp430x2011" ] ; then
+ARCH=msp:20
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0xF800
+ROM_SIZE=0x07e0
+RAM_START=0x0200
+RAM_SIZE=128
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x280
+fi
+
+if [ "${MSP430_NAME}" = "msp430x2002" ] ; then
+ARCH=msp:20
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0xFC00
+ROM_SIZE=0x03e0
+RAM_START=0x0200
+RAM_SIZE=128
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x280
+fi
+
+if [ "${MSP430_NAME}" = "msp430x2012" ] ; then
+ARCH=msp:20
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0xF800
+ROM_SIZE=0x07e0
+RAM_START=0x0200
+RAM_SIZE=128
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x280
+fi
+
+if [ "${MSP430_NAME}" = "msp430x2003" ] ; then
+ARCH=msp:20
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0xFC00
+ROM_SIZE=0x03e0
+RAM_START=0x0200
+RAM_SIZE=128
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x280
+fi
+
+if [ "${MSP430_NAME}" = "msp430x2013" ] ; then
+ARCH=msp:20
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0xF800
+ROM_SIZE=0x07e0
+RAM_START=0x0200
+RAM_SIZE=128
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x280
+fi
+
 if [ "${MSP430_NAME}" = "msp430x2101" ] ; then
 ARCH=msp:21
 MACHINE=
 SCRIPT_NAME=elf32msp430
 OUTPUT_FORMAT="elf32-msp430"
@@ -474,10 +699,12 @@
 
 ROM_START=0xFC00
 ROM_SIZE=0x03e0
 RAM_START=0x0200
 RAM_SIZE=128
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x280
 fi
 
 if [ "${MSP430_NAME}" = "msp430x2111" ] ; then
@@ -491,10 +718,12 @@
 
 ROM_START=0xF800
 ROM_SIZE=0x07e0
 RAM_START=0x0200
 RAM_SIZE=128
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x280
 fi
 
 if [ "${MSP430_NAME}" = "msp430x2121" ] ; then
@@ -508,10 +737,12 @@
 
 ROM_START=0xf000
 ROM_SIZE=0x0fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x2131" ] ; then
@@ -525,14 +756,73 @@
 
 ROM_START=0xe000
 ROM_SIZE=0x1fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x300
+fi
+
+if [ "${MSP430_NAME}" = "msp430x2234" ] ; then
+ARCH=msp:22
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0xe000
+ROM_SIZE=0x1fe0
+RAM_START=0x0200
+RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
+if [ "${MSP430_NAME}" = "msp430x2254" ] ; then
+ARCH=msp:22
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0xc000
+ROM_SIZE=0x3fe0
+RAM_START=0x0200
+RAM_SIZE=512
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x400
+fi
+
+if [ "${MSP430_NAME}" = "msp430x2274" ] ; then
+ARCH=msp:22
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0x8000
+ROM_SIZE=0x7fe0
+RAM_START=0x0200
+RAM_SIZE=1024
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x600
+fi
+
 if [ "${MSP430_NAME}" = "msp430x311" ] ; then
 ARCH=msp:31
 MACHINE=
 SCRIPT_NAME=elf32msp430_3
 OUTPUT_FORMAT="elf32-msp430"
@@ -542,10 +832,12 @@
 
 ROM_START=0xf800
 ROM_SIZE=0x07e0
 RAM_START=0x0200
 RAM_SIZE=128
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x280
 fi
 
 if [ "${MSP430_NAME}" = "msp430x312" ] ; then
@@ -559,10 +851,12 @@
 
 ROM_START=0xf000
 ROM_SIZE=0x0fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x313" ] ; then
@@ -576,10 +870,12 @@
 
 ROM_START=0xe000
 ROM_SIZE=0x1fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x314" ] ; then
@@ -593,10 +889,12 @@
 
 ROM_START=0xd000
 ROM_SIZE=0x2fe0
 RAM_START=0x0200
 RAM_SIZE=512
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x400
 fi
 
 if [ "${MSP430_NAME}" = "msp430x315" ] ; then
@@ -610,10 +908,12 @@
 
 ROM_START=0xc000
 ROM_SIZE=0x3fe0
 RAM_START=0x0200
 RAM_SIZE=512
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x400
 fi
 
 if [ "${MSP430_NAME}" = "msp430x323" ] ; then
@@ -627,10 +927,12 @@
 
 ROM_START=0xe000
 ROM_SIZE=0x1fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x325" ] ; then
@@ -644,10 +946,12 @@
 
 ROM_START=0xc000
 ROM_SIZE=0x3fe0
 RAM_START=0x0200
 RAM_SIZE=512
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x400
 fi
 
 if [ "${MSP430_NAME}" = "msp430x336" ] ; then
@@ -661,10 +965,12 @@
 
 ROM_START=0xa000
 ROM_SIZE=0x5fe0
 RAM_START=0x0200
 RAM_SIZE=1024
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x600
 fi
 
 if [ "${MSP430_NAME}" = "msp430x337" ] ; then
@@ -678,10 +984,12 @@
 
 ROM_START=0x8000
 ROM_SIZE=0x7fe0
 RAM_START=0x0200
 RAM_SIZE=1024
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x600
 fi
 
 if [ "${MSP430_NAME}" = "msp430x412" ] ; then
@@ -695,10 +1003,12 @@
 
 ROM_START=0xf000
 ROM_SIZE=0x0fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x413" ] ; then
@@ -712,10 +1022,12 @@
 
 ROM_START=0xe000
 ROM_SIZE=0x1fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430x415" ] ; then
@@ -729,10 +1041,12 @@
 
 ROM_START=0xc000
 ROM_SIZE=0x3fe0
 RAM_START=0x0200
 RAM_SIZE=512
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x400
 fi
 
 if [ "${MSP430_NAME}" = "msp430x417" ] ; then
@@ -746,14 +1060,130 @@
 
 ROM_START=0x8000
 ROM_SIZE=0x7fe0
 RAM_START=0x0200
 RAM_SIZE=1024
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x600
 fi
 
+if [ "${MSP430_NAME}" = "msp430x423" ] ; then
+ARCH=msp:42
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0xe000
+ROM_SIZE=0x1fe0
+RAM_START=0x0200
+RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x300
+fi
+
+if [ "${MSP430_NAME}" = "msp430x425" ] ; then
+ARCH=msp:42
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0xc000
+ROM_SIZE=0x3fe0
+RAM_START=0x0200
+RAM_SIZE=512
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x400
+fi
+
+if [ "${MSP430_NAME}" = "msp430x427" ] ; then
+ARCH=msp:42
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0x8000
+ROM_SIZE=0x7fe0
+RAM_START=0x0200
+RAM_SIZE=1024
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x600
+fi
+
+if [ "${MSP430_NAME}" = "msp430x4250" ] ; then
+ARCH=msp:42
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0xc000
+ROM_SIZE=0x3fe0
+RAM_START=0x0200
+RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x300
+fi
+
+if [ "${MSP430_NAME}" = "msp430x4260" ] ; then
+ARCH=msp:42
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0xa000
+ROM_SIZE=0x5fe0
+RAM_START=0x0200
+RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x300
+fi
+
+if [ "${MSP430_NAME}" = "msp430x4270" ] ; then
+ARCH=msp:42
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0x8000
+ROM_SIZE=0x7fe0
+RAM_START=0x0200
+RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
+
+STACK=0x300
+fi
+
 if [ "${MSP430_NAME}" = "msp430x435" ] ; then
 ARCH=msp:43
 MACHINE=
 SCRIPT_NAME=elf32msp430
 OUTPUT_FORMAT="elf32-msp430"
@@ -763,10 +1193,12 @@
 
 ROM_START=0xc000
 ROM_SIZE=0x3fe0
 RAM_START=0x0200
 RAM_SIZE=512
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x400
 fi
 
 if [ "${MSP430_NAME}" = "msp430x436" ] ; then
@@ -780,10 +1212,12 @@
 
 ROM_START=0xa000
 ROM_SIZE=0x5fe0
 RAM_START=0x0200
 RAM_SIZE=1024
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x600
 fi
 
 if [ "${MSP430_NAME}" = "msp430x437" ] ; then
@@ -797,10 +1231,12 @@
 
 ROM_START=0x8000
 ROM_SIZE=0x7fe0
 RAM_START=0x0200
 RAM_SIZE=1024
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x600
 fi
 
 if [ "${MSP430_NAME}" = "msp430x447" ] ; then
@@ -814,10 +1250,12 @@
 
 ROM_START=0x8000
 ROM_SIZE=0x7fe0
 RAM_START=0x0200
 RAM_SIZE=1024
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x600
 fi
 
 if [ "${MSP430_NAME}" = "msp430x448" ] ; then
@@ -831,10 +1269,12 @@
 
 ROM_START=0x4000
 ROM_SIZE=0xbfe0
 RAM_START=0x0200
 RAM_SIZE=0x0800
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0xa00
 fi
 
 if [ "${MSP430_NAME}" = "msp430x449" ] ; then
@@ -848,10 +1288,12 @@
 
 ROM_START=0x1100
 ROM_SIZE=0xeee0
 RAM_START=0x0200
 RAM_SIZE=0x0800
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0xa00
 fi
 
 if [ "${MSP430_NAME}" = "msp430xE423" ] ; then
@@ -865,10 +1307,12 @@
 
 ROM_START=0xe000
 ROM_SIZE=0x1fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430xE425" ] ; then
@@ -882,10 +1326,12 @@
 
 ROM_START=0xc000
 ROM_SIZE=0x3fe0
 RAM_START=0x0200
 RAM_SIZE=512
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x400
 fi
 
 if [ "${MSP430_NAME}" = "msp430xE427" ] ; then
@@ -899,10 +1345,12 @@
 
 ROM_START=0x8000
 ROM_SIZE=0x7fe0
 RAM_START=0x0200
 RAM_SIZE=1024
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x600
 fi
 
 if [ "${MSP430_NAME}" = "msp430xG437" ] ; then
@@ -916,10 +1364,12 @@
 
 ROM_START=0x8000
 ROM_SIZE=0x7fe0
 RAM_START=0x0200
 RAM_SIZE=1024
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x600
 fi
 
 if [ "${MSP430_NAME}" = "msp430xG438" ] ; then
@@ -933,10 +1383,12 @@
 
 ROM_START=0x4000
 ROM_SIZE=0xbef0
 RAM_START=0x0200
 RAM_SIZE=0x0800
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0xa00
 fi
 
 if [ "${MSP430_NAME}" = "msp430xG439" ] ; then
@@ -950,14 +1402,92 @@
 
 ROM_START=0x1100
 ROM_SIZE=0xeee0
 RAM_START=0x0200
 RAM_SIZE=0x0800
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0xa00
 fi
 
+if [ "${MSP430_NAME}" = "msp430xG4616" ] ; then
+ARCH=msp:46
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0x9100
+ROM_SIZE=0x6ec0
+RAM_START=0x1100
+RAM_SIZE=0x1000
+VECTORS_START=0xffc0
+VECTORS_SIZE=64
+
+STACK=0x2100
+fi
+
+if [ "${MSP430_NAME}" = "msp430xG4617" ] ; then
+ARCH=msp:46
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0x9100
+ROM_SIZE=0x6ec0
+RAM_START=0x1100
+RAM_SIZE=0x2000
+VECTORS_START=0xffc0
+VECTORS_SIZE=64
+
+STACK=0x3100
+fi
+
+if [ "${MSP430_NAME}" = "msp430xG4618" ] ; then
+ARCH=msp:46
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0x3100
+ROM_SIZE=0xcec0
+RAM_START=0x1100
+RAM_SIZE=0x2000
+VECTORS_START=0xffc0
+VECTORS_SIZE=64
+
+STACK=0x3100
+fi
+
+if [ "${MSP430_NAME}" = "msp430xG4619" ] ; then
+ARCH=msp:46
+MACHINE=
+SCRIPT_NAME=elf32msp430
+OUTPUT_FORMAT="elf32-msp430"
+MAXPAGESIZE=1
+EMBEDDED=yes
+TEMPLATE_NAME=generic
+
+ROM_START=0x2100
+ROM_SIZE=0xdec0
+RAM_START=0x1100
+RAM_SIZE=0x1000
+VECTORS_START=0xffc0
+VECTORS_SIZE=64
+
+STACK=0x2100
+fi
+
 if [ "${MSP430_NAME}" = "msp430xW423" ] ; then
 ARCH=msp:42
 MACHINE=
 SCRIPT_NAME=elf32msp430
 OUTPUT_FORMAT="elf32-msp430"
@@ -967,10 +1497,12 @@
 
 ROM_START=0xe000
 ROM_SIZE=0x1fe0
 RAM_START=0x0200
 RAM_SIZE=256
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x300
 fi
 
 if [ "${MSP430_NAME}" = "msp430xW425" ] ; then
@@ -984,10 +1516,12 @@
 
 ROM_START=0xc000
 ROM_SIZE=0x3fe0
 RAM_START=0x0200
 RAM_SIZE=512
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x400
 fi
 
 if [ "${MSP430_NAME}" = "msp430xW427" ] ; then
@@ -1001,8 +1535,10 @@
 
 ROM_START=0x8000
 ROM_SIZE=0x7fe0
 RAM_START=0x0200
 RAM_SIZE=0x400
+VECTORS_START=0xffe0
+VECTORS_SIZE=32
 
 STACK=0x600
 fi
diff -rU5 binutils-060402.orig/ld/Makefile.am binutils-060402/ld/Makefile.am
--- binutils-060402.orig/ld/Makefile.am	2006-03-26 08:46:13.000000000 +0800
+++ binutils-060402/ld/Makefile.am	2006-11-16 00:05:33.000000000 +0800
@@ -284,23 +284,35 @@
 	emsp430x1331.o \
 	emsp430x1351.o \
 	emsp430x147.o \
 	emsp430x148.o \
 	emsp430x149.o \
+	emsp430x1471.o \
+	emsp430x1481.o \
+	emsp430x1491.o \
 	emsp430x155.o \
 	emsp430x156.o \
 	emsp430x157.o \
 	emsp430x167.o \
 	emsp430x168.o \
 	emsp430x169.o \
 	emsp430x1610.o \
 	emsp430x1611.o \
 	emsp430x1612.o \
+	emsp430x2001.o \
+	emsp430x2011.o \
+	emsp430x2002.o \
+	emsp430x2012.o \
+	emsp430x2003.o \
+	emsp430x2014.o \
 	emsp430x2101.o \
 	emsp430x2111.o \
 	emsp430x2121.o \
 	emsp430x2131.o \
+	emsp430x2234.o \
+	emsp430x2254.o \
+	emsp430x2274.o \
 	emsp430x311.o \
 	emsp430x312.o \
 	emsp430x313.o \
 	emsp430x314.o \
 	emsp430x315.o \
@@ -310,10 +322,16 @@
 	emsp430x337.o \
 	emsp430x412.o \
 	emsp430x413.o \
 	emsp430x415.o \
 	emsp430x417.o \
+	emsp430x423.o \
+	emsp430x425.o \
+	emsp430x427.o \
+	emsp430x4250.o \
+	emsp430x4260.o \
+	emsp430x4270.o \
 	emsp430xE423.o \
 	emsp430xE425.o \
 	emsp430xE427.o \
 	emsp430xW423.o \
 	emsp430xW425.o \
@@ -325,10 +343,14 @@
 	emsp430x436.o \
 	emsp430x437.o \
 	emsp430x447.o \
 	emsp430x448.o \
 	emsp430x449.o \
+	emsp430xG4616.o \
+	emsp430xG4617.o \
+	emsp430xG4618.o \
+	emsp430xG4619.o \
 	enews.o \
 	ens32knbsd.o \
 	eor32.o \
 	eor32elf.o \
 	epc532macha.o \
@@ -1224,10 +1246,22 @@
 	${GENSCRIPTS} msp430x148 "$(tdir_msp430x148)" msp430all
 emsp430x149.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x149 "$(tdir_msp430x149)" msp430all
+emsp430x1471.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x1471 "$(tdir_msp430x1471)" msp430all
+emsp430x1481.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x1481 "$(tdir_msp430x1481)" msp430all
+emsp430x1491.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x1491 "$(tdir_msp430x1491)" msp430all
 emsp430x155.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x155 "$(tdir_msp430x155)" msp430all
 emsp430x156.c: $(srcdir)/emulparams/msp430all.sh \
@@ -1260,10 +1294,34 @@
 	${GENSCRIPTS} msp430x1611 "$(tdir_msp430x1611)" msp430all
 emsp430x1612.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x1612 "$(tdir_msp430x1612)" msp430all
+emsp430x2001.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2001 "$(tdir_msp430x2001)" msp430all
+emsp430x2011.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2011 "$(tdir_msp430x2011)" msp430all
+emsp430x2002.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2002 "$(tdir_msp430x2002)" msp430all
+emsp430x2012.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2012 "$(tdir_msp430x2012)" msp430all
+emsp430x2003.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2003 "$(tdir_msp430x2003)" msp430all
+emsp430x2013.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2013 "$(tdir_msp430x2013)" msp430all
 emsp430x2101.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x2101 "$(tdir_msp430x2101)" msp430all
 emsp430x2111.c: $(srcdir)/emulparams/msp430all.sh \
@@ -1276,10 +1334,22 @@
 	${GENSCRIPTS} msp430x2121 "$(tdir_msp430x2121)" msp430all
 emsp430x2131.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x2131 "$(tdir_msp430x2131)" msp430all
+emsp430x2234.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2234 "$(tdir_msp430x2234)" msp430all
+emsp430x2254.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2254 "$(tdir_msp430x2254)" msp430all
+emsp430x2274.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2274 "$(tdir_msp430x2274)" msp430all
 emsp430x311.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430_3.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x311 "$(tdir_msp430x311)" msp430all
 emsp430x312.c: $(srcdir)/emulparams/msp430all.sh \
@@ -1328,10 +1398,34 @@
 	${GENSCRIPTS} msp430x415 "$(tdir_msp430x415)" msp430all
 emsp430x417.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x417 "$(tdir_msp430x417)" msp430all
+emsp430x423.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x423 "$(tdir_msp430x423)" msp430all
+emsp430x425.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x425 "$(tdir_msp430x425)" msp430all
+emsp430x427.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x427 "$(tdir_msp430x427)" msp430all
+emsp430x4250.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x4250 "$(tdir_msp430x4250)" msp430all
+emsp430x4260.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x4260 "$(tdir_msp430x4260)" msp430all
+emsp430x4270.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x4270 "$(tdir_msp430x4270)" msp430all
 emsp430xE423.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430xE423 "$(tdir_msp430xE423)" msp430all
 emsp430xE425.c: $(srcdir)/emulparams/msp430all.sh \
@@ -1388,10 +1482,26 @@
 	${GENSCRIPTS} msp430x448 "$(tdir_msp430x448)" msp430all
 emsp430x449.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x449 "$(tdir_msp430x449)" msp430all
+emsp430xG4616.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430xG4616 "$(tdir_msp430xG4616)" msp430all
+emsp430xG4617.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430xG4617 "$(tdir_msp430xG4617)" msp430all
+emsp430xG4618.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430xG4618 "$(tdir_msp430xG4618)" msp430all
+emsp430xG4619.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430xG4619 "$(tdir_msp430xG4619)" msp430all
 enews.c: $(srcdir)/emulparams/news.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/aout.sc ${GEN_DEPENDS}
 	${GENSCRIPTS} news "$(tdir_news)"
 ens32knbsd.c:	$(srcdir)/emulparams/ns32knbsd.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/emultempl/netbsd.em \
diff -rU5 binutils-060402.orig/ld/Makefile.in binutils-060402/ld/Makefile.in
--- binutils-060402.orig/ld/Makefile.in	2006-03-26 08:46:13.000000000 +0800
+++ binutils-060402/ld/Makefile.in	2006-11-16 00:05:33.000000000 +0800
@@ -507,23 +507,35 @@
 	emsp430x1331.o \
 	emsp430x1351.o \
 	emsp430x147.o \
 	emsp430x148.o \
 	emsp430x149.o \
+	emsp430x1471.o \
+	emsp430x1481.o \
+	emsp430x1491.o \
 	emsp430x155.o \
 	emsp430x156.o \
 	emsp430x157.o \
 	emsp430x167.o \
 	emsp430x168.o \
 	emsp430x169.o \
 	emsp430x1610.o \
 	emsp430x1611.o \
 	emsp430x1612.o \
+	emsp430x2001.o \
+	emsp430x2011.o \
+	emsp430x2002.o \
+	emsp430x2012.o \
+	emsp430x2003.o \
+	emsp430x2013.o \
 	emsp430x2101.o \
 	emsp430x2111.o \
 	emsp430x2121.o \
 	emsp430x2131.o \
+	emsp430x2234.o \
+	emsp430x2254.o \
+	emsp430x2274.o \
 	emsp430x311.o \
 	emsp430x312.o \
 	emsp430x313.o \
 	emsp430x314.o \
 	emsp430x315.o \
@@ -533,10 +545,16 @@
 	emsp430x337.o \
 	emsp430x412.o \
 	emsp430x413.o \
 	emsp430x415.o \
 	emsp430x417.o \
+	emsp430x423.o \
+	emsp430x425.o \
+	emsp430x427.o \
+	emsp430x4250.o \
+	emsp430x4260.o \
+	emsp430x4270.o \
 	emsp430xE423.o \
 	emsp430xE425.o \
 	emsp430xE427.o \
 	emsp430xW423.o \
 	emsp430xW425.o \
@@ -548,10 +566,14 @@
 	emsp430x436.o \
 	emsp430x437.o \
 	emsp430x447.o \
 	emsp430x448.o \
 	emsp430x449.o \
+	emsp430xG4616.o \
+	emsp430xG4617.o \
+	emsp430xG4618.o \
+	emsp430xG4619.o \
 	enews.o \
 	ens32knbsd.o \
 	eor32.o \
 	eor32elf.o \
 	epc532macha.o \
@@ -2030,10 +2052,22 @@
 	${GENSCRIPTS} msp430x148 "$(tdir_msp430x148)" msp430all
 emsp430x149.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x149 "$(tdir_msp430x149)" msp430all
+emsp430x1471.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x1471 "$(tdir_msp430x1471)" msp430all
+emsp430x1481.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x1481 "$(tdir_msp430x1481)" msp430all
+emsp430x1491.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x1491 "$(tdir_msp430x1491)" msp430all
 emsp430x155.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x155 "$(tdir_msp430x155)" msp430all
 emsp430x156.c: $(srcdir)/emulparams/msp430all.sh \
@@ -2066,10 +2100,34 @@
 	${GENSCRIPTS} msp430x1611 "$(tdir_msp430x1611)" msp430all
 emsp430x1612.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x1612 "$(tdir_msp430x1612)" msp430all
+emsp430x2001.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2001 "$(tdir_msp430x2001)" msp430all
+emsp430x2011.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2011 "$(tdir_msp430x2011)" msp430all
+emsp430x2002.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2002 "$(tdir_msp430x2002)" msp430all
+emsp430x2012.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2012 "$(tdir_msp430x2012)" msp430all
+emsp430x2003.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2003 "$(tdir_msp430x2003)" msp430all
+emsp430x2013.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2013 "$(tdir_msp430x2013)" msp430all
 emsp430x2101.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x2101 "$(tdir_msp430x2101)" msp430all
 emsp430x2111.c: $(srcdir)/emulparams/msp430all.sh \
@@ -2082,10 +2140,22 @@
 	${GENSCRIPTS} msp430x2121 "$(tdir_msp430x2121)" msp430all
 emsp430x2131.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x2131 "$(tdir_msp430x2131)" msp430all
+emsp430x2234.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2234 "$(tdir_msp430x2234)" msp430all
+emsp430x2254.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2254 "$(tdir_msp430x2254)" msp430all
+emsp430x2274.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x2274 "$(tdir_msp430x2274)" msp430all
 emsp430x311.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430_3.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x311 "$(tdir_msp430x311)" msp430all
 emsp430x312.c: $(srcdir)/emulparams/msp430all.sh \
@@ -2134,10 +2204,34 @@
 	${GENSCRIPTS} msp430x415 "$(tdir_msp430x415)" msp430all
 emsp430x417.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x417 "$(tdir_msp430x417)" msp430all
+emsp430x423.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x423 "$(tdir_msp430x423)" msp430all
+emsp430x425.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x425 "$(tdir_msp430x425)" msp430all
+emsp430x427.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x427 "$(tdir_msp430x427)" msp430all
+emsp430x4250.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x4250 "$(tdir_msp430x4250)" msp430all
+emsp430x4260.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x4260 "$(tdir_msp430x4260)" msp430all
+emsp430x4270.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430x4270 "$(tdir_msp430x4270)" msp430all
 emsp430xE423.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430xE423 "$(tdir_msp430xE423)" msp430all
 emsp430xE425.c: $(srcdir)/emulparams/msp430all.sh \
@@ -2194,10 +2288,26 @@
 	${GENSCRIPTS} msp430x448 "$(tdir_msp430x448)" msp430all
 emsp430x449.c: $(srcdir)/emulparams/msp430all.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
   ${GEN_DEPENDS}
 	${GENSCRIPTS} msp430x449 "$(tdir_msp430x449)" msp430all
+emsp430xG4616.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430xG4616 "$(tdir_msp430xG4616)" msp430all
+emsp430xG4617.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430xG4617 "$(tdir_msp430xG4617)" msp430all
+emsp430xG4618.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430xG4618 "$(tdir_msp430xG4618)" msp430all
+emsp430xG4619.c: $(srcdir)/emulparams/msp430all.sh \
+  $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/elf32msp430.sc \
+  ${GEN_DEPENDS}
+	${GENSCRIPTS} msp430xG4619 "$(tdir_msp430xG4619)" msp430all
 enews.c: $(srcdir)/emulparams/news.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/scripttempl/aout.sc ${GEN_DEPENDS}
 	${GENSCRIPTS} news "$(tdir_news)"
 ens32knbsd.c:	$(srcdir)/emulparams/ns32knbsd.sh \
   $(srcdir)/emultempl/generic.em $(srcdir)/emultempl/netbsd.em \
diff -rU5 binutils-060402.orig/ld/scripttempl/elf32msp430_3.sc binutils-060402/ld/scripttempl/elf32msp430_3.sc
--- binutils-060402.orig/ld/scripttempl/elf32msp430_3.sc	2003-04-09 19:07:51.000000000 +0800
+++ binutils-060402/ld/scripttempl/elf32msp430_3.sc	2006-11-16 00:05:33.000000000 +0800
@@ -2,13 +2,13 @@
 OUTPUT_FORMAT("${OUTPUT_FORMAT}","${OUTPUT_FORMAT}","${OUTPUT_FORMAT}")
 OUTPUT_ARCH(${ARCH})
 
 MEMORY
 {
-  text   (rx)   : ORIGIN = $ROM_START,  LENGTH = $ROM_SIZE
-  data   (rwx)  : ORIGIN = $RAM_START, 	LENGTH = $RAM_SIZE
-  vectors (rw)  : ORIGIN = 0xffe0,      LENGTH = 0x20
+  text   (rx)   : ORIGIN = $ROM_START,    LENGTH = $ROM_SIZE
+  data   (rwx)  : ORIGIN = $RAM_START, 	  LENGTH = $RAM_SIZE
+  vectors (rw)  : ORIGIN = $VECTORS_START LENGTH = $VECTORS_SIZE
 }
 
 SECTIONS
 {
   /* Read-only sections, merged into text segment.  */
diff -rU5 binutils-060402.orig/ld/scripttempl/elf32msp430.sc binutils-060402/ld/scripttempl/elf32msp430.sc
--- binutils-060402.orig/ld/scripttempl/elf32msp430.sc	2004-08-25 20:54:10.000000000 +0800
+++ binutils-060402/ld/scripttempl/elf32msp430.sc	2006-11-16 00:05:33.000000000 +0800
@@ -22,16 +22,16 @@
 OUTPUT_FORMAT("${OUTPUT_FORMAT}","${OUTPUT_FORMAT}","${OUTPUT_FORMAT}")
 OUTPUT_ARCH(${ARCH})
 
 MEMORY
 {
-  text   (rx)   	: ORIGIN = $ROM_START,  LENGTH = $ROM_SIZE
-  data   (rwx)  	: ORIGIN = $RAM_START, 	LENGTH = $RAM_SIZE
-  vectors (rw)  	: ORIGIN = 0xffe0,      LENGTH = 0x20
-  bootloader(rx)	: ORIGIN = 0x0c00,	LENGTH = 1K
-  infomem(rx)		: ORIGIN = 0x1000,	LENGTH = 256
-  infomemnobits(rx)	: ORIGIN = 0x1000,      LENGTH = 256
+  text   (rx)   	: ORIGIN = $ROM_START,    LENGTH = $ROM_SIZE
+  data   (rwx)  	: ORIGIN = $RAM_START, 	  LENGTH = $RAM_SIZE
+  vectors (rw)  	: ORIGIN = $VECTORS_START LENGTH = $VECTORS_SIZE
+  bootloader(rx)	: ORIGIN = 0x0c00,	      LENGTH = 1K
+  infomem(rx)		: ORIGIN = 0x1000,	      LENGTH = 256
+  infomemnobits(rx)	: ORIGIN = 0x1000,        LENGTH = 256
   ${HEAP_MEMORY_MSP430}
 }
 
 SECTIONS
 {
diff -rU5 binutils-060402.orig/opcodes/msp430-dis.c binutils-060402/opcodes/msp430-dis.c
--- binutils-060402/opcodes/msp430-dis.c	2006-11-17 21:10:59.000000000 +0800
+++ binutils-060402.orig/opcodes/msp430-dis.c	2005-07-01 19:16:32.000000000 +0800
@@ -675,11 +675,13 @@
   char dinfo[32];		/* Debug purposes.  */
 
   insn = msp430dis_opcode (addr, info);
   sprintf (dinfo, "0x%04x", insn);
 
-  if (((int) addr & 0xffff) > 0xffdf)
+  if (((int) addr & 0xffff) >= 0xffe0
+      ||
+      (info->mach == 46  &&  ((int) addr & 0xffff) >= 0xffc0))
     {
       (*prin) (stream, "interrupt service routine at 0x%04x", 0xffff & insn);
       return 2;
     }
 
